# coding: utf-8

"""
    Yahoo!広告 ディスプレイ広告 API リファレンス / Yahoo! JAPAN Ads Display Ads API Reference

    <div lang=\"ja\">Yahoo!広告 ディスプレイ広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Display Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/design/v12/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v12
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_display_test.configuration import Configuration


class AdGroupTargetServiceSelector(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'account_id': 'int',
        'ad_group_ids': 'list[int]',
        'campaign_ids': 'list[int]',
        'target_types': 'list[AdGroupTargetServiceTargetType]',
        'area_search_types': 'list[AdGroupTargetServiceAreaSearchType]',
        'sort_field': 'AdGroupTargetServiceSortField',
        'sort_type': 'AdGroupTargetServiceSortType',
        'number_results': 'int',
        'start_index': 'int'
    }

    attribute_map = {
        'account_id': 'accountId',
        'ad_group_ids': 'adGroupIds',
        'campaign_ids': 'campaignIds',
        'target_types': 'targetTypes',
        'area_search_types': 'areaSearchTypes',
        'sort_field': 'sortField',
        'sort_type': 'sortType',
        'number_results': 'numberResults',
        'start_index': 'startIndex'
    }

    def __init__(self, account_id=None, ad_group_ids=None, campaign_ids=None, target_types=None, area_search_types=None, sort_field=None, sort_type=None, number_results=1000, start_index=1, local_vars_configuration=None):  # noqa: E501
        """AdGroupTargetServiceSelector - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._account_id = None
        self._ad_group_ids = None
        self._campaign_ids = None
        self._target_types = None
        self._area_search_types = None
        self._sort_field = None
        self._sort_type = None
        self._number_results = None
        self._start_index = None
        self.discriminator = None

        self.account_id = account_id
        self.ad_group_ids = ad_group_ids
        self.campaign_ids = campaign_ids
        self.target_types = target_types
        self.area_search_types = area_search_types
        self.sort_field = sort_field
        self.sort_type = sort_type
        self.number_results = number_results
        self.start_index = start_index

    @property
    def account_id(self):
        """Gets the account_id of this AdGroupTargetServiceSelector.  # noqa: E501

        <div lang=\"ja\">アカウントIDです。</div> <div lang=\"en\">Account ID</div>   # noqa: E501

        :return: The account_id of this AdGroupTargetServiceSelector.  # noqa: E501
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this AdGroupTargetServiceSelector.

        <div lang=\"ja\">アカウントIDです。</div> <div lang=\"en\">Account ID</div>   # noqa: E501

        :param account_id: The account_id of this AdGroupTargetServiceSelector.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and account_id is None:  # noqa: E501
            raise ValueError("Invalid value for `account_id`, must not be `None`")  # noqa: E501

        self._account_id = account_id

    @property
    def ad_group_ids(self):
        """Gets the ad_group_ids of this AdGroupTargetServiceSelector.  # noqa: E501

        <div lang=\"ja\">広告グループIDです。</div> <div lang=\"en\">Ad group ID</div>   # noqa: E501

        :return: The ad_group_ids of this AdGroupTargetServiceSelector.  # noqa: E501
        :rtype: list[int]
        """
        return self._ad_group_ids

    @ad_group_ids.setter
    def ad_group_ids(self, ad_group_ids):
        """Sets the ad_group_ids of this AdGroupTargetServiceSelector.

        <div lang=\"ja\">広告グループIDです。</div> <div lang=\"en\">Ad group ID</div>   # noqa: E501

        :param ad_group_ids: The ad_group_ids of this AdGroupTargetServiceSelector.  # noqa: E501
        :type: list[int]
        """

        self._ad_group_ids = ad_group_ids

    @property
    def campaign_ids(self):
        """Gets the campaign_ids of this AdGroupTargetServiceSelector.  # noqa: E501

        <div lang=\"ja\">キャンペーンIDです。</div> <div lang=\"en\">Campaign ID</div>   # noqa: E501

        :return: The campaign_ids of this AdGroupTargetServiceSelector.  # noqa: E501
        :rtype: list[int]
        """
        return self._campaign_ids

    @campaign_ids.setter
    def campaign_ids(self, campaign_ids):
        """Sets the campaign_ids of this AdGroupTargetServiceSelector.

        <div lang=\"ja\">キャンペーンIDです。</div> <div lang=\"en\">Campaign ID</div>   # noqa: E501

        :param campaign_ids: The campaign_ids of this AdGroupTargetServiceSelector.  # noqa: E501
        :type: list[int]
        """

        self._campaign_ids = campaign_ids

    @property
    def target_types(self):
        """Gets the target_types of this AdGroupTargetServiceSelector.  # noqa: E501


        :return: The target_types of this AdGroupTargetServiceSelector.  # noqa: E501
        :rtype: list[AdGroupTargetServiceTargetType]
        """
        return self._target_types

    @target_types.setter
    def target_types(self, target_types):
        """Sets the target_types of this AdGroupTargetServiceSelector.


        :param target_types: The target_types of this AdGroupTargetServiceSelector.  # noqa: E501
        :type: list[AdGroupTargetServiceTargetType]
        """

        self._target_types = target_types

    @property
    def area_search_types(self):
        """Gets the area_search_types of this AdGroupTargetServiceSelector.  # noqa: E501


        :return: The area_search_types of this AdGroupTargetServiceSelector.  # noqa: E501
        :rtype: list[AdGroupTargetServiceAreaSearchType]
        """
        return self._area_search_types

    @area_search_types.setter
    def area_search_types(self, area_search_types):
        """Sets the area_search_types of this AdGroupTargetServiceSelector.


        :param area_search_types: The area_search_types of this AdGroupTargetServiceSelector.  # noqa: E501
        :type: list[AdGroupTargetServiceAreaSearchType]
        """

        self._area_search_types = area_search_types

    @property
    def sort_field(self):
        """Gets the sort_field of this AdGroupTargetServiceSelector.  # noqa: E501


        :return: The sort_field of this AdGroupTargetServiceSelector.  # noqa: E501
        :rtype: AdGroupTargetServiceSortField
        """
        return self._sort_field

    @sort_field.setter
    def sort_field(self, sort_field):
        """Sets the sort_field of this AdGroupTargetServiceSelector.


        :param sort_field: The sort_field of this AdGroupTargetServiceSelector.  # noqa: E501
        :type: AdGroupTargetServiceSortField
        """

        self._sort_field = sort_field

    @property
    def sort_type(self):
        """Gets the sort_type of this AdGroupTargetServiceSelector.  # noqa: E501


        :return: The sort_type of this AdGroupTargetServiceSelector.  # noqa: E501
        :rtype: AdGroupTargetServiceSortType
        """
        return self._sort_type

    @sort_type.setter
    def sort_type(self, sort_type):
        """Sets the sort_type of this AdGroupTargetServiceSelector.


        :param sort_type: The sort_type of this AdGroupTargetServiceSelector.  # noqa: E501
        :type: AdGroupTargetServiceSortType
        """

        self._sort_type = sort_type

    @property
    def number_results(self):
        """Gets the number_results of this AdGroupTargetServiceSelector.  # noqa: E501

        <div lang=\"ja\">ページの最大件数です。このフィールドは、1以上を指定する必要があります。</div> <div lang=\"en\">Maximum number of results to return in this page. This field must be greater than or equal to 1. Also see Entity Limits per operation.</div>   # noqa: E501

        :return: The number_results of this AdGroupTargetServiceSelector.  # noqa: E501
        :rtype: int
        """
        return self._number_results

    @number_results.setter
    def number_results(self, number_results):
        """Sets the number_results of this AdGroupTargetServiceSelector.

        <div lang=\"ja\">ページの最大件数です。このフィールドは、1以上を指定する必要があります。</div> <div lang=\"en\">Maximum number of results to return in this page. This field must be greater than or equal to 1. Also see Entity Limits per operation.</div>   # noqa: E501

        :param number_results: The number_results of this AdGroupTargetServiceSelector.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                number_results is not None and number_results > 10000):  # noqa: E501
            raise ValueError("Invalid value for `number_results`, must be a value less than or equal to `10000`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                number_results is not None and number_results < 1):  # noqa: E501
            raise ValueError("Invalid value for `number_results`, must be a value greater than or equal to `1`")  # noqa: E501

        self._number_results = number_results

    @property
    def start_index(self):
        """Gets the start_index of this AdGroupTargetServiceSelector.  # noqa: E501

        <div lang=\"ja\">ページの先頭のインデックスです。このフィールドは、1以上を指定する必要があります。</div> <div lang=\"en\">Index of the first result to return in this page. This field must be greater than or equal to 1.</div>   # noqa: E501

        :return: The start_index of this AdGroupTargetServiceSelector.  # noqa: E501
        :rtype: int
        """
        return self._start_index

    @start_index.setter
    def start_index(self, start_index):
        """Sets the start_index of this AdGroupTargetServiceSelector.

        <div lang=\"ja\">ページの先頭のインデックスです。このフィールドは、1以上を指定する必要があります。</div> <div lang=\"en\">Index of the first result to return in this page. This field must be greater than or equal to 1.</div>   # noqa: E501

        :param start_index: The start_index of this AdGroupTargetServiceSelector.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                start_index is not None and start_index < 1):  # noqa: E501
            raise ValueError("Invalid value for `start_index`, must be a value greater than or equal to `1`")  # noqa: E501

        self._start_index = start_index

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AdGroupTargetServiceSelector):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AdGroupTargetServiceSelector):
            return True

        return self.to_dict() != other.to_dict()
