# coding: utf-8

"""
    Yahoo!広告 ディスプレイ広告 API リファレンス / Yahoo! JAPAN Ads Display Ads API Reference

    <div lang=\"ja\">Yahoo!広告 ディスプレイ広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Display Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/design/v12/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v12
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_display_test.configuration import Configuration


class AudienceList(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'account_id': 'int',
        'delivery_status': 'AudienceListServiceDeliveryStatus',
        'description': 'str',
        'is_remove_description': 'AudienceListServiceIsRemoveFlg',
        'reach': 'int',
        'audience_list_content': 'AudienceListServiceContent',
        'audience_list_id': 'int',
        'audience_list_name': 'str',
        'source_account_id': 'int',
        'source_account_name': 'str',
        'source_type': 'AudienceListServiceSourceType',
        'is_shared': 'bool',
        'data_connection_stopped': 'AudienceListServiceDataConnectionStopped'
    }

    attribute_map = {
        'account_id': 'accountId',
        'delivery_status': 'deliveryStatus',
        'description': 'description',
        'is_remove_description': 'isRemoveDescription',
        'reach': 'reach',
        'audience_list_content': 'audienceListContent',
        'audience_list_id': 'audienceListId',
        'audience_list_name': 'audienceListName',
        'source_account_id': 'sourceAccountId',
        'source_account_name': 'sourceAccountName',
        'source_type': 'sourceType',
        'is_shared': 'isShared',
        'data_connection_stopped': 'dataConnectionStopped'
    }

    def __init__(self, account_id=None, delivery_status=None, description=None, is_remove_description=None, reach=None, audience_list_content=None, audience_list_id=None, audience_list_name=None, source_account_id=None, source_account_name=None, source_type=None, is_shared=None, data_connection_stopped=None, local_vars_configuration=None):  # noqa: E501
        """AudienceList - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._account_id = None
        self._delivery_status = None
        self._description = None
        self._is_remove_description = None
        self._reach = None
        self._audience_list_content = None
        self._audience_list_id = None
        self._audience_list_name = None
        self._source_account_id = None
        self._source_account_name = None
        self._source_type = None
        self._is_shared = None
        self._data_connection_stopped = None
        self.discriminator = None

        self.account_id = account_id
        self.delivery_status = delivery_status
        self.description = description
        self.is_remove_description = is_remove_description
        self.reach = reach
        self.audience_list_content = audience_list_content
        self.audience_list_id = audience_list_id
        self.audience_list_name = audience_list_name
        self.source_account_id = source_account_id
        self.source_account_name = source_account_name
        self.source_type = source_type
        self.is_shared = is_shared
        self.data_connection_stopped = data_connection_stopped

    @property
    def account_id(self):
        """Gets the account_id of this AudienceList.  # noqa: E501

        <div lang=\"ja\"> アカウントIDです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Account ID.<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :return: The account_id of this AudienceList.  # noqa: E501
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this AudienceList.

        <div lang=\"ja\"> アカウントIDです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Account ID.<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :param account_id: The account_id of this AudienceList.  # noqa: E501
        :type: int
        """

        self._account_id = account_id

    @property
    def delivery_status(self):
        """Gets the delivery_status of this AudienceList.  # noqa: E501


        :return: The delivery_status of this AudienceList.  # noqa: E501
        :rtype: AudienceListServiceDeliveryStatus
        """
        return self._delivery_status

    @delivery_status.setter
    def delivery_status(self, delivery_status):
        """Sets the delivery_status of this AudienceList.


        :param delivery_status: The delivery_status of this AudienceList.  # noqa: E501
        :type: AudienceListServiceDeliveryStatus
        """

        self._delivery_status = delivery_status

    @property
    def description(self):
        """Gets the description of this AudienceList.  # noqa: E501

        <div lang=\"ja\"> オーディエンスリストの説明です。<br> このフィールドは、ADDおよびSET時に省略可能となり、REMOVE時に無視されます。 </div> <div lang=\"en\"> Description of audience list.<br> This field is optional in ADD and SET operation, and will be ignored in REMOVE operation. </div>   # noqa: E501

        :return: The description of this AudienceList.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this AudienceList.

        <div lang=\"ja\"> オーディエンスリストの説明です。<br> このフィールドは、ADDおよびSET時に省略可能となり、REMOVE時に無視されます。 </div> <div lang=\"en\"> Description of audience list.<br> This field is optional in ADD and SET operation, and will be ignored in REMOVE operation. </div>   # noqa: E501

        :param description: The description of this AudienceList.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def is_remove_description(self):
        """Gets the is_remove_description of this AudienceList.  # noqa: E501


        :return: The is_remove_description of this AudienceList.  # noqa: E501
        :rtype: AudienceListServiceIsRemoveFlg
        """
        return self._is_remove_description

    @is_remove_description.setter
    def is_remove_description(self, is_remove_description):
        """Sets the is_remove_description of this AudienceList.


        :param is_remove_description: The is_remove_description of this AudienceList.  # noqa: E501
        :type: AudienceListServiceIsRemoveFlg
        """

        self._is_remove_description = is_remove_description

    @property
    def reach(self):
        """Gets the reach of this AudienceList.  # noqa: E501

        <div lang=\"ja\"> リーチ数です。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Number of reaches.<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :return: The reach of this AudienceList.  # noqa: E501
        :rtype: int
        """
        return self._reach

    @reach.setter
    def reach(self, reach):
        """Sets the reach of this AudienceList.

        <div lang=\"ja\"> リーチ数です。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Number of reaches.<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :param reach: The reach of this AudienceList.  # noqa: E501
        :type: int
        """

        self._reach = reach

    @property
    def audience_list_content(self):
        """Gets the audience_list_content of this AudienceList.  # noqa: E501


        :return: The audience_list_content of this AudienceList.  # noqa: E501
        :rtype: AudienceListServiceContent
        """
        return self._audience_list_content

    @audience_list_content.setter
    def audience_list_content(self, audience_list_content):
        """Sets the audience_list_content of this AudienceList.


        :param audience_list_content: The audience_list_content of this AudienceList.  # noqa: E501
        :type: AudienceListServiceContent
        """

        self._audience_list_content = audience_list_content

    @property
    def audience_list_id(self):
        """Gets the audience_list_id of this AudienceList.  # noqa: E501

        <div lang=\"ja\"> オーディエンスリストIDです。<br> このフィールドは、SETおよびREMOVE時に必須となり、ADD時には無視されます。 </div> <div lang=\"en\"> Audience list ID.<br> This field is required in SET and REMOVE operation, and will be ignored in ADD operation. </div>   # noqa: E501

        :return: The audience_list_id of this AudienceList.  # noqa: E501
        :rtype: int
        """
        return self._audience_list_id

    @audience_list_id.setter
    def audience_list_id(self, audience_list_id):
        """Sets the audience_list_id of this AudienceList.

        <div lang=\"ja\"> オーディエンスリストIDです。<br> このフィールドは、SETおよびREMOVE時に必須となり、ADD時には無視されます。 </div> <div lang=\"en\"> Audience list ID.<br> This field is required in SET and REMOVE operation, and will be ignored in ADD operation. </div>   # noqa: E501

        :param audience_list_id: The audience_list_id of this AudienceList.  # noqa: E501
        :type: int
        """

        self._audience_list_id = audience_list_id

    @property
    def audience_list_name(self):
        """Gets the audience_list_name of this AudienceList.  # noqa: E501

        <div lang=\"ja\"> オーディエンスリスト名です。<br> このフィールドは、ADD時は必須、SET時は省略可能となり、REMOVE時は無視されます。 </div> <div lang=\"en\"> Audience list name.<br> This field is required in ADD operation, optional in SET operation, and will be ignored in REMOVE operation. </div>   # noqa: E501

        :return: The audience_list_name of this AudienceList.  # noqa: E501
        :rtype: str
        """
        return self._audience_list_name

    @audience_list_name.setter
    def audience_list_name(self, audience_list_name):
        """Sets the audience_list_name of this AudienceList.

        <div lang=\"ja\"> オーディエンスリスト名です。<br> このフィールドは、ADD時は必須、SET時は省略可能となり、REMOVE時は無視されます。 </div> <div lang=\"en\"> Audience list name.<br> This field is required in ADD operation, optional in SET operation, and will be ignored in REMOVE operation. </div>   # noqa: E501

        :param audience_list_name: The audience_list_name of this AudienceList.  # noqa: E501
        :type: str
        """

        self._audience_list_name = audience_list_name

    @property
    def source_account_id(self):
        """Gets the source_account_id of this AudienceList.  # noqa: E501

        <div lang=\"ja\">   共有元アカウントIDです。<br>   このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\">   Account ID of the sharing source.<br>   Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :return: The source_account_id of this AudienceList.  # noqa: E501
        :rtype: int
        """
        return self._source_account_id

    @source_account_id.setter
    def source_account_id(self, source_account_id):
        """Sets the source_account_id of this AudienceList.

        <div lang=\"ja\">   共有元アカウントIDです。<br>   このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\">   Account ID of the sharing source.<br>   Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :param source_account_id: The source_account_id of this AudienceList.  # noqa: E501
        :type: int
        """

        self._source_account_id = source_account_id

    @property
    def source_account_name(self):
        """Gets the source_account_name of this AudienceList.  # noqa: E501

        <div lang=\"ja\">   共有元アカウント名です。<br>   このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\">   Account name of the sharing source.<br>   Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :return: The source_account_name of this AudienceList.  # noqa: E501
        :rtype: str
        """
        return self._source_account_name

    @source_account_name.setter
    def source_account_name(self, source_account_name):
        """Sets the source_account_name of this AudienceList.

        <div lang=\"ja\">   共有元アカウント名です。<br>   このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\">   Account name of the sharing source.<br>   Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :param source_account_name: The source_account_name of this AudienceList.  # noqa: E501
        :type: str
        """

        self._source_account_name = source_account_name

    @property
    def source_type(self):
        """Gets the source_type of this AudienceList.  # noqa: E501


        :return: The source_type of this AudienceList.  # noqa: E501
        :rtype: AudienceListServiceSourceType
        """
        return self._source_type

    @source_type.setter
    def source_type(self, source_type):
        """Sets the source_type of this AudienceList.


        :param source_type: The source_type of this AudienceList.  # noqa: E501
        :type: AudienceListServiceSourceType
        """

        self._source_type = source_type

    @property
    def is_shared(self):
        """Gets the is_shared of this AudienceList.  # noqa: E501

        <div lang=\"ja\">   AudienceListServiceIsSharedは、オーディエンスリストの共有ステータスを示します。<br>   このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\">   AudienceListServiceIsShared describes the sharing status of the audience list.<br>   Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :return: The is_shared of this AudienceList.  # noqa: E501
        :rtype: bool
        """
        return self._is_shared

    @is_shared.setter
    def is_shared(self, is_shared):
        """Sets the is_shared of this AudienceList.

        <div lang=\"ja\">   AudienceListServiceIsSharedは、オーディエンスリストの共有ステータスを示します。<br>   このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\">   AudienceListServiceIsShared describes the sharing status of the audience list.<br>   Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :param is_shared: The is_shared of this AudienceList.  # noqa: E501
        :type: bool
        """

        self._is_shared = is_shared

    @property
    def data_connection_stopped(self):
        """Gets the data_connection_stopped of this AudienceList.  # noqa: E501


        :return: The data_connection_stopped of this AudienceList.  # noqa: E501
        :rtype: AudienceListServiceDataConnectionStopped
        """
        return self._data_connection_stopped

    @data_connection_stopped.setter
    def data_connection_stopped(self, data_connection_stopped):
        """Sets the data_connection_stopped of this AudienceList.


        :param data_connection_stopped: The data_connection_stopped of this AudienceList.  # noqa: E501
        :type: AudienceListServiceDataConnectionStopped
        """

        self._data_connection_stopped = data_connection_stopped

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AudienceList):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AudienceList):
            return True

        return self.to_dict() != other.to_dict()
