# coding: utf-8

"""
    Yahoo!広告 ディスプレイ広告 API リファレンス / Yahoo! JAPAN Ads Display Ads API Reference

    <div lang=\"ja\">Yahoo!広告 ディスプレイ広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Display Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/design/v12/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v12
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_display_test.configuration import Configuration


class AudienceListServiceCustomerDataAudienceList(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'custom_audience_id': 'str',
        'reach_period': 'int'
    }

    attribute_map = {
        'custom_audience_id': 'customAudienceId',
        'reach_period': 'reachPeriod'
    }

    def __init__(self, custom_audience_id=None, reach_period=None, local_vars_configuration=None):  # noqa: E501
        """AudienceListServiceCustomerDataAudienceList - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._custom_audience_id = None
        self._reach_period = None
        self.discriminator = None

        self.custom_audience_id = custom_audience_id
        self.reach_period = reach_period

    @property
    def custom_audience_id(self):
        """Gets the custom_audience_id of this AudienceListServiceCustomerDataAudienceList.  # noqa: E501

        <div lang=\"ja\">カスタムオーディエンスID（サイトリターゲティングID）です。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\">Custom audience ID (site retargeting ID).<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :return: The custom_audience_id of this AudienceListServiceCustomerDataAudienceList.  # noqa: E501
        :rtype: str
        """
        return self._custom_audience_id

    @custom_audience_id.setter
    def custom_audience_id(self, custom_audience_id):
        """Sets the custom_audience_id of this AudienceListServiceCustomerDataAudienceList.

        <div lang=\"ja\">カスタムオーディエンスID（サイトリターゲティングID）です。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\">Custom audience ID (site retargeting ID).<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :param custom_audience_id: The custom_audience_id of this AudienceListServiceCustomerDataAudienceList.  # noqa: E501
        :type: str
        """

        self._custom_audience_id = custom_audience_id

    @property
    def reach_period(self):
        """Gets the reach_period of this AudienceListServiceCustomerDataAudienceList.  # noqa: E501

        <div lang=\"ja\"> 行動履歴の保持期間です（1日～60日）。<br> このフィールドは、ADD時に必須となります。 </div> <div lang=\"en\"> Duration of user data configured from DMP (1-60days). <br> This field is required in ADD operation. </div>   # noqa: E501

        :return: The reach_period of this AudienceListServiceCustomerDataAudienceList.  # noqa: E501
        :rtype: int
        """
        return self._reach_period

    @reach_period.setter
    def reach_period(self, reach_period):
        """Sets the reach_period of this AudienceListServiceCustomerDataAudienceList.

        <div lang=\"ja\"> 行動履歴の保持期間です（1日～60日）。<br> このフィールドは、ADD時に必須となります。 </div> <div lang=\"en\"> Duration of user data configured from DMP (1-60days). <br> This field is required in ADD operation. </div>   # noqa: E501

        :param reach_period: The reach_period of this AudienceListServiceCustomerDataAudienceList.  # noqa: E501
        :type: int
        """

        self._reach_period = reach_period

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AudienceListServiceCustomerDataAudienceList):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AudienceListServiceCustomerDataAudienceList):
            return True

        return self.to_dict() != other.to_dict()
