# coding: utf-8

"""
    Yahoo!広告 ディスプレイ広告 API リファレンス / Yahoo! JAPAN Ads Display Ads API Reference

    <div lang=\"ja\">Yahoo!広告 ディスプレイ広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Display Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/design/v12/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v12
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_display_test.configuration import Configuration


class BrandLiftServiceSelector(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'account_id': 'int',
        'brand_lift_ids': 'list[int]',
        'campaign_ids': 'list[int]',
        'approval_statuses': 'list[BrandLiftServiceApprovalStatus]',
        'number_results': 'int',
        'start_index': 'int'
    }

    attribute_map = {
        'account_id': 'accountId',
        'brand_lift_ids': 'brandLiftIds',
        'campaign_ids': 'campaignIds',
        'approval_statuses': 'approvalStatuses',
        'number_results': 'numberResults',
        'start_index': 'startIndex'
    }

    def __init__(self, account_id=None, brand_lift_ids=None, campaign_ids=None, approval_statuses=None, number_results=500, start_index=1, local_vars_configuration=None):  # noqa: E501
        """BrandLiftServiceSelector - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._account_id = None
        self._brand_lift_ids = None
        self._campaign_ids = None
        self._approval_statuses = None
        self._number_results = None
        self._start_index = None
        self.discriminator = None

        self.account_id = account_id
        self.brand_lift_ids = brand_lift_ids
        self.campaign_ids = campaign_ids
        self.approval_statuses = approval_statuses
        self.number_results = number_results
        self.start_index = start_index

    @property
    def account_id(self):
        """Gets the account_id of this BrandLiftServiceSelector.  # noqa: E501

        <div lang=\"ja\">検索条件 : アカウントID</div> <div lang=\"en\">Search condition: Account ID</div>   # noqa: E501

        :return: The account_id of this BrandLiftServiceSelector.  # noqa: E501
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this BrandLiftServiceSelector.

        <div lang=\"ja\">検索条件 : アカウントID</div> <div lang=\"en\">Search condition: Account ID</div>   # noqa: E501

        :param account_id: The account_id of this BrandLiftServiceSelector.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and account_id is None:  # noqa: E501
            raise ValueError("Invalid value for `account_id`, must not be `None`")  # noqa: E501

        self._account_id = account_id

    @property
    def brand_lift_ids(self):
        """Gets the brand_lift_ids of this BrandLiftServiceSelector.  # noqa: E501

        <div lang=\"ja\">検索条件 : ブランドリフト調査ID</div> <div lang=\"en\">Search condition: BrandLift ID</div>   # noqa: E501

        :return: The brand_lift_ids of this BrandLiftServiceSelector.  # noqa: E501
        :rtype: list[int]
        """
        return self._brand_lift_ids

    @brand_lift_ids.setter
    def brand_lift_ids(self, brand_lift_ids):
        """Sets the brand_lift_ids of this BrandLiftServiceSelector.

        <div lang=\"ja\">検索条件 : ブランドリフト調査ID</div> <div lang=\"en\">Search condition: BrandLift ID</div>   # noqa: E501

        :param brand_lift_ids: The brand_lift_ids of this BrandLiftServiceSelector.  # noqa: E501
        :type: list[int]
        """

        self._brand_lift_ids = brand_lift_ids

    @property
    def campaign_ids(self):
        """Gets the campaign_ids of this BrandLiftServiceSelector.  # noqa: E501

        <div lang=\"ja\">検索条件 : キャンペーンID</div> <div lang=\"en\">Search condition: Campaign ID</div>   # noqa: E501

        :return: The campaign_ids of this BrandLiftServiceSelector.  # noqa: E501
        :rtype: list[int]
        """
        return self._campaign_ids

    @campaign_ids.setter
    def campaign_ids(self, campaign_ids):
        """Sets the campaign_ids of this BrandLiftServiceSelector.

        <div lang=\"ja\">検索条件 : キャンペーンID</div> <div lang=\"en\">Search condition: Campaign ID</div>   # noqa: E501

        :param campaign_ids: The campaign_ids of this BrandLiftServiceSelector.  # noqa: E501
        :type: list[int]
        """

        self._campaign_ids = campaign_ids

    @property
    def approval_statuses(self):
        """Gets the approval_statuses of this BrandLiftServiceSelector.  # noqa: E501


        :return: The approval_statuses of this BrandLiftServiceSelector.  # noqa: E501
        :rtype: list[BrandLiftServiceApprovalStatus]
        """
        return self._approval_statuses

    @approval_statuses.setter
    def approval_statuses(self, approval_statuses):
        """Sets the approval_statuses of this BrandLiftServiceSelector.


        :param approval_statuses: The approval_statuses of this BrandLiftServiceSelector.  # noqa: E501
        :type: list[BrandLiftServiceApprovalStatus]
        """

        self._approval_statuses = approval_statuses

    @property
    def number_results(self):
        """Gets the number_results of this BrandLiftServiceSelector.  # noqa: E501

        <div lang=\"ja\">ページの最大件数です。このフィールドは、1以上を指定する必要があります。</div> <div lang=\"en\">Maximum number of results to return in this page. This field must be greater than or equal to 1. Also see Entity Limits per operation.</div>   # noqa: E501

        :return: The number_results of this BrandLiftServiceSelector.  # noqa: E501
        :rtype: int
        """
        return self._number_results

    @number_results.setter
    def number_results(self, number_results):
        """Sets the number_results of this BrandLiftServiceSelector.

        <div lang=\"ja\">ページの最大件数です。このフィールドは、1以上を指定する必要があります。</div> <div lang=\"en\">Maximum number of results to return in this page. This field must be greater than or equal to 1. Also see Entity Limits per operation.</div>   # noqa: E501

        :param number_results: The number_results of this BrandLiftServiceSelector.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                number_results is not None and number_results > 500):  # noqa: E501
            raise ValueError("Invalid value for `number_results`, must be a value less than or equal to `500`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                number_results is not None and number_results < 1):  # noqa: E501
            raise ValueError("Invalid value for `number_results`, must be a value greater than or equal to `1`")  # noqa: E501

        self._number_results = number_results

    @property
    def start_index(self):
        """Gets the start_index of this BrandLiftServiceSelector.  # noqa: E501

        <div lang=\"ja\">ページの先頭のインデックスです。このフィールドは、1以上を指定する必要があります。</div> <div lang=\"en\">Index of the first result to return in this page. This field must be greater than or equal to 1.</div>   # noqa: E501

        :return: The start_index of this BrandLiftServiceSelector.  # noqa: E501
        :rtype: int
        """
        return self._start_index

    @start_index.setter
    def start_index(self, start_index):
        """Sets the start_index of this BrandLiftServiceSelector.

        <div lang=\"ja\">ページの先頭のインデックスです。このフィールドは、1以上を指定する必要があります。</div> <div lang=\"en\">Index of the first result to return in this page. This field must be greater than or equal to 1.</div>   # noqa: E501

        :param start_index: The start_index of this BrandLiftServiceSelector.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                start_index is not None and start_index < 1):  # noqa: E501
            raise ValueError("Invalid value for `start_index`, must be a value greater than or equal to `1`")  # noqa: E501

        self._start_index = start_index

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BrandLiftServiceSelector):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, BrandLiftServiceSelector):
            return True

        return self.to_dict() != other.to_dict()
