# coding: utf-8

"""
    Yahoo!広告 ディスプレイ広告 API リファレンス / Yahoo! JAPAN Ads Display Ads API Reference

    <div lang=\"ja\">Yahoo!広告 ディスプレイ広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Display Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/design/v12/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v12
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_display_test.configuration import Configuration


class BudgetOrder(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'account_id': 'int',
        'account_type': 'BudgetOrderServiceAccountType',
        'amount': 'int',
        'limit_charge_type': 'BudgetOrderServiceLimitChargeType'
    }

    attribute_map = {
        'account_id': 'accountId',
        'account_type': 'accountType',
        'amount': 'amount',
        'limit_charge_type': 'limitChargeType'
    }

    def __init__(self, account_id=None, account_type=None, amount=None, limit_charge_type=None, local_vars_configuration=None):  # noqa: E501
        """BudgetOrder - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._account_id = None
        self._account_type = None
        self._amount = None
        self._limit_charge_type = None
        self.discriminator = None

        self.account_id = account_id
        self.account_type = account_type
        self.amount = amount
        self.limit_charge_type = limit_charge_type

    @property
    def account_id(self):
        """Gets the account_id of this BudgetOrder.  # noqa: E501

        <div lang=\"ja\"> アカウントIDです。<br> SET時、このフィールドは必須となります。 </div> <div lang=\"en\"> Account ID.<br> This field is required in SET operation. </div>   # noqa: E501

        :return: The account_id of this BudgetOrder.  # noqa: E501
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this BudgetOrder.

        <div lang=\"ja\"> アカウントIDです。<br> SET時、このフィールドは必須となります。 </div> <div lang=\"en\"> Account ID.<br> This field is required in SET operation. </div>   # noqa: E501

        :param account_id: The account_id of this BudgetOrder.  # noqa: E501
        :type: int
        """

        self._account_id = account_id

    @property
    def account_type(self):
        """Gets the account_type of this BudgetOrder.  # noqa: E501


        :return: The account_type of this BudgetOrder.  # noqa: E501
        :rtype: BudgetOrderServiceAccountType
        """
        return self._account_type

    @account_type.setter
    def account_type(self, account_type):
        """Sets the account_type of this BudgetOrder.


        :param account_type: The account_type of this BudgetOrder.  # noqa: E501
        :type: BudgetOrderServiceAccountType
        """

        self._account_type = account_type

    @property
    def amount(self):
        """Gets the amount of this BudgetOrder.  # noqa: E501

        <div lang=\"ja\"> アカウントの広告予算金額です。<br> SET時、このフィールドは省略可能となります。 月額予算は、accountTypeが<code>INVOICE</code>の場合のみ変更可能です。 また、予算額は1000円単位で指定する必要があります。 </div> <div lang=\"en\"> Amount of budget.<br> This field is optional in SET operation. The monthly budget can be changed only when accountType is <code>INVOICE</code>. In addition, the budget amount must be specified in units of 1000 yen. </div>   # noqa: E501

        :return: The amount of this BudgetOrder.  # noqa: E501
        :rtype: int
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this BudgetOrder.

        <div lang=\"ja\"> アカウントの広告予算金額です。<br> SET時、このフィールドは省略可能となります。 月額予算は、accountTypeが<code>INVOICE</code>の場合のみ変更可能です。 また、予算額は1000円単位で指定する必要があります。 </div> <div lang=\"en\"> Amount of budget.<br> This field is optional in SET operation. The monthly budget can be changed only when accountType is <code>INVOICE</code>. In addition, the budget amount must be specified in units of 1000 yen. </div>   # noqa: E501

        :param amount: The amount of this BudgetOrder.  # noqa: E501
        :type: int
        """

        self._amount = amount

    @property
    def limit_charge_type(self):
        """Gets the limit_charge_type of this BudgetOrder.  # noqa: E501


        :return: The limit_charge_type of this BudgetOrder.  # noqa: E501
        :rtype: BudgetOrderServiceLimitChargeType
        """
        return self._limit_charge_type

    @limit_charge_type.setter
    def limit_charge_type(self, limit_charge_type):
        """Sets the limit_charge_type of this BudgetOrder.


        :param limit_charge_type: The limit_charge_type of this BudgetOrder.  # noqa: E501
        :type: BudgetOrderServiceLimitChargeType
        """

        self._limit_charge_type = limit_charge_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BudgetOrder):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, BudgetOrder):
            return True

        return self.to_dict() != other.to_dict()
