# coding: utf-8

"""
    Yahoo!広告 ディスプレイ広告 API リファレンス / Yahoo! JAPAN Ads Display Ads API Reference

    <div lang=\"ja\">Yahoo!広告 ディスプレイ広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Display Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/design/v12/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v12
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_display_test.configuration import Configuration


class FeedSetServiceSelector(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'account_id': 'int',
        'feed_id': 'int',
        'feed_set_ids': 'list[int]',
        'include_item_count': 'bool'
    }

    attribute_map = {
        'account_id': 'accountId',
        'feed_id': 'feedId',
        'feed_set_ids': 'feedSetIds',
        'include_item_count': 'includeItemCount'
    }

    def __init__(self, account_id=None, feed_id=None, feed_set_ids=None, include_item_count=None, local_vars_configuration=None):  # noqa: E501
        """FeedSetServiceSelector - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._account_id = None
        self._feed_id = None
        self._feed_set_ids = None
        self._include_item_count = None
        self.discriminator = None

        self.account_id = account_id
        self.feed_id = feed_id
        self.feed_set_ids = feed_set_ids
        self.include_item_count = include_item_count

    @property
    def account_id(self):
        """Gets the account_id of this FeedSetServiceSelector.  # noqa: E501

        <div lang=\"ja\">アカウントID</div> <div lang=\"en\">Account ID.</div>   # noqa: E501

        :return: The account_id of this FeedSetServiceSelector.  # noqa: E501
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this FeedSetServiceSelector.

        <div lang=\"ja\">アカウントID</div> <div lang=\"en\">Account ID.</div>   # noqa: E501

        :param account_id: The account_id of this FeedSetServiceSelector.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and account_id is None:  # noqa: E501
            raise ValueError("Invalid value for `account_id`, must not be `None`")  # noqa: E501

        self._account_id = account_id

    @property
    def feed_id(self):
        """Gets the feed_id of this FeedSetServiceSelector.  # noqa: E501

        <div lang=\"ja\">フィードID</div> <div lang=\"en\">Feed ID.</div>   # noqa: E501

        :return: The feed_id of this FeedSetServiceSelector.  # noqa: E501
        :rtype: int
        """
        return self._feed_id

    @feed_id.setter
    def feed_id(self, feed_id):
        """Sets the feed_id of this FeedSetServiceSelector.

        <div lang=\"ja\">フィードID</div> <div lang=\"en\">Feed ID.</div>   # noqa: E501

        :param feed_id: The feed_id of this FeedSetServiceSelector.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and feed_id is None:  # noqa: E501
            raise ValueError("Invalid value for `feed_id`, must not be `None`")  # noqa: E501

        self._feed_id = feed_id

    @property
    def feed_set_ids(self):
        """Gets the feed_set_ids of this FeedSetServiceSelector.  # noqa: E501

        <div lang=\"ja\">商品セットID</div> <div lang=\"en\">Item set ID.</div>   # noqa: E501

        :return: The feed_set_ids of this FeedSetServiceSelector.  # noqa: E501
        :rtype: list[int]
        """
        return self._feed_set_ids

    @feed_set_ids.setter
    def feed_set_ids(self, feed_set_ids):
        """Sets the feed_set_ids of this FeedSetServiceSelector.

        <div lang=\"ja\">商品セットID</div> <div lang=\"en\">Item set ID.</div>   # noqa: E501

        :param feed_set_ids: The feed_set_ids of this FeedSetServiceSelector.  # noqa: E501
        :type: list[int]
        """

        self._feed_set_ids = feed_set_ids

    @property
    def include_item_count(self):
        """Gets the include_item_count of this FeedSetServiceSelector.  # noqa: E501

        <div lang=\"ja\"> 商品セットのアイテム件数を表示<br> trueの場合は、アイテム件数を表示<br> ※デフォルト値はfalse:表示しない。 </div> <div lang=\"en\"> Describes number of items of Item Set.<br> If true, the number of items is described.<br> ∗ Default is false: Not described. </div>   # noqa: E501

        :return: The include_item_count of this FeedSetServiceSelector.  # noqa: E501
        :rtype: bool
        """
        return self._include_item_count

    @include_item_count.setter
    def include_item_count(self, include_item_count):
        """Sets the include_item_count of this FeedSetServiceSelector.

        <div lang=\"ja\"> 商品セットのアイテム件数を表示<br> trueの場合は、アイテム件数を表示<br> ※デフォルト値はfalse:表示しない。 </div> <div lang=\"en\"> Describes number of items of Item Set.<br> If true, the number of items is described.<br> ∗ Default is false: Not described. </div>   # noqa: E501

        :param include_item_count: The include_item_count of this FeedSetServiceSelector.  # noqa: E501
        :type: bool
        """

        self._include_item_count = include_item_count

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FeedSetServiceSelector):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, FeedSetServiceSelector):
            return True

        return self.to_dict() != other.to_dict()
