# coding: utf-8

"""
    Yahoo!広告 ディスプレイ広告 API リファレンス / Yahoo! JAPAN Ads Display Ads API Reference

    <div lang=\"ja\">Yahoo!広告 ディスプレイ広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Display Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/design/v12/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v12
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_display_test.configuration import Configuration


class GuaranteedAdGroupAdServiceCarouselAd(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'display_url': 'str',
        'logo_media_id': 'int',
        'principal': 'str',
        'custom_parameters': 'GuaranteedAdGroupAdServiceCustomParameters',
        'display_url_level': 'GuaranteedAdGroupAdServiceDisplayUrlLevel',
        'final_url': 'str',
        'smartphone_final_url': 'str',
        'tracking_url': 'str',
        'carousels': 'list[GuaranteedAdGroupAdServiceCarousel]'
    }

    attribute_map = {
        'display_url': 'displayUrl',
        'logo_media_id': 'logoMediaId',
        'principal': 'principal',
        'custom_parameters': 'customParameters',
        'display_url_level': 'displayUrlLevel',
        'final_url': 'finalUrl',
        'smartphone_final_url': 'smartphoneFinalUrl',
        'tracking_url': 'trackingUrl',
        'carousels': 'carousels'
    }

    def __init__(self, display_url=None, logo_media_id=None, principal=None, custom_parameters=None, display_url_level=None, final_url=None, smartphone_final_url=None, tracking_url=None, carousels=None, local_vars_configuration=None):  # noqa: E501
        """GuaranteedAdGroupAdServiceCarouselAd - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._display_url = None
        self._logo_media_id = None
        self._principal = None
        self._custom_parameters = None
        self._display_url_level = None
        self._final_url = None
        self._smartphone_final_url = None
        self._tracking_url = None
        self._carousels = None
        self.discriminator = None

        self.display_url = display_url
        self.logo_media_id = logo_media_id
        self.principal = principal
        self.custom_parameters = custom_parameters
        self.display_url_level = display_url_level
        self.final_url = final_url
        self.smartphone_final_url = smartphone_final_url
        self.tracking_url = tracking_url
        self.carousels = carousels

    @property
    def display_url(self):
        """Gets the display_url of this GuaranteedAdGroupAdServiceCarouselAd.  # noqa: E501

        <div lang=\"ja\"> 表示URLです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。<br> </div> <div lang=\"en\"> Display URL.<br> This field will be returned in the response, it will be ignored on input.<br> </div>   # noqa: E501

        :return: The display_url of this GuaranteedAdGroupAdServiceCarouselAd.  # noqa: E501
        :rtype: str
        """
        return self._display_url

    @display_url.setter
    def display_url(self, display_url):
        """Sets the display_url of this GuaranteedAdGroupAdServiceCarouselAd.

        <div lang=\"ja\"> 表示URLです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。<br> </div> <div lang=\"en\"> Display URL.<br> This field will be returned in the response, it will be ignored on input.<br> </div>   # noqa: E501

        :param display_url: The display_url of this GuaranteedAdGroupAdServiceCarouselAd.  # noqa: E501
        :type: str
        """

        self._display_url = display_url

    @property
    def logo_media_id(self):
        """Gets the logo_media_id of this GuaranteedAdGroupAdServiceCarouselAd.  # noqa: E501

        <div lang=\"ja\"> ロゴの画像IDです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Logo image ID.<br> This field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :return: The logo_media_id of this GuaranteedAdGroupAdServiceCarouselAd.  # noqa: E501
        :rtype: int
        """
        return self._logo_media_id

    @logo_media_id.setter
    def logo_media_id(self, logo_media_id):
        """Sets the logo_media_id of this GuaranteedAdGroupAdServiceCarouselAd.

        <div lang=\"ja\"> ロゴの画像IDです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Logo image ID.<br> This field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :param logo_media_id: The logo_media_id of this GuaranteedAdGroupAdServiceCarouselAd.  # noqa: E501
        :type: int
        """

        self._logo_media_id = logo_media_id

    @property
    def principal(self):
        """Gets the principal of this GuaranteedAdGroupAdServiceCarouselAd.  # noqa: E501

        <div lang=\"ja\"> 広告の主体者表記です。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Advertiser indication of the ad.<br> This field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :return: The principal of this GuaranteedAdGroupAdServiceCarouselAd.  # noqa: E501
        :rtype: str
        """
        return self._principal

    @principal.setter
    def principal(self, principal):
        """Sets the principal of this GuaranteedAdGroupAdServiceCarouselAd.

        <div lang=\"ja\"> 広告の主体者表記です。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Advertiser indication of the ad.<br> This field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :param principal: The principal of this GuaranteedAdGroupAdServiceCarouselAd.  # noqa: E501
        :type: str
        """

        self._principal = principal

    @property
    def custom_parameters(self):
        """Gets the custom_parameters of this GuaranteedAdGroupAdServiceCarouselAd.  # noqa: E501


        :return: The custom_parameters of this GuaranteedAdGroupAdServiceCarouselAd.  # noqa: E501
        :rtype: GuaranteedAdGroupAdServiceCustomParameters
        """
        return self._custom_parameters

    @custom_parameters.setter
    def custom_parameters(self, custom_parameters):
        """Sets the custom_parameters of this GuaranteedAdGroupAdServiceCarouselAd.


        :param custom_parameters: The custom_parameters of this GuaranteedAdGroupAdServiceCarouselAd.  # noqa: E501
        :type: GuaranteedAdGroupAdServiceCustomParameters
        """

        self._custom_parameters = custom_parameters

    @property
    def display_url_level(self):
        """Gets the display_url_level of this GuaranteedAdGroupAdServiceCarouselAd.  # noqa: E501


        :return: The display_url_level of this GuaranteedAdGroupAdServiceCarouselAd.  # noqa: E501
        :rtype: GuaranteedAdGroupAdServiceDisplayUrlLevel
        """
        return self._display_url_level

    @display_url_level.setter
    def display_url_level(self, display_url_level):
        """Sets the display_url_level of this GuaranteedAdGroupAdServiceCarouselAd.


        :param display_url_level: The display_url_level of this GuaranteedAdGroupAdServiceCarouselAd.  # noqa: E501
        :type: GuaranteedAdGroupAdServiceDisplayUrlLevel
        """

        self._display_url_level = display_url_level

    @property
    def final_url(self):
        """Gets the final_url of this GuaranteedAdGroupAdServiceCarouselAd.  # noqa: E501

        <div lang=\"ja\">最終リンク先URLです。<br> finalUrlフィールドを設定する場合、trackingUrl、customParametersは任意になります。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。<br> ※現在利用できません </div> <div lang=\"en\">Final URL.<br> If you specify finalUrl, trackingUrl and customParameters will be optional.<br> This field will be returned in the response, it will be ignored on input.<br> * Not Available. </div>   # noqa: E501

        :return: The final_url of this GuaranteedAdGroupAdServiceCarouselAd.  # noqa: E501
        :rtype: str
        """
        return self._final_url

    @final_url.setter
    def final_url(self, final_url):
        """Sets the final_url of this GuaranteedAdGroupAdServiceCarouselAd.

        <div lang=\"ja\">最終リンク先URLです。<br> finalUrlフィールドを設定する場合、trackingUrl、customParametersは任意になります。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。<br> ※現在利用できません </div> <div lang=\"en\">Final URL.<br> If you specify finalUrl, trackingUrl and customParameters will be optional.<br> This field will be returned in the response, it will be ignored on input.<br> * Not Available. </div>   # noqa: E501

        :param final_url: The final_url of this GuaranteedAdGroupAdServiceCarouselAd.  # noqa: E501
        :type: str
        """

        self._final_url = final_url

    @property
    def smartphone_final_url(self):
        """Gets the smartphone_final_url of this GuaranteedAdGroupAdServiceCarouselAd.  # noqa: E501

        <div lang=\"ja\">スマートフォン向けURLです。<br> finalUrlを指定するときのみ、任意で指定できます。<br> ※現在利用できません </div> <div lang=\"en\">Final URL (smartphone).<br> This field can be optionally specified only when specifying finalUrl.<br> * Not Available. </div>   # noqa: E501

        :return: The smartphone_final_url of this GuaranteedAdGroupAdServiceCarouselAd.  # noqa: E501
        :rtype: str
        """
        return self._smartphone_final_url

    @smartphone_final_url.setter
    def smartphone_final_url(self, smartphone_final_url):
        """Sets the smartphone_final_url of this GuaranteedAdGroupAdServiceCarouselAd.

        <div lang=\"ja\">スマートフォン向けURLです。<br> finalUrlを指定するときのみ、任意で指定できます。<br> ※現在利用できません </div> <div lang=\"en\">Final URL (smartphone).<br> This field can be optionally specified only when specifying finalUrl.<br> * Not Available. </div>   # noqa: E501

        :param smartphone_final_url: The smartphone_final_url of this GuaranteedAdGroupAdServiceCarouselAd.  # noqa: E501
        :type: str
        """

        self._smartphone_final_url = smartphone_final_url

    @property
    def tracking_url(self):
        """Gets the tracking_url of this GuaranteedAdGroupAdServiceCarouselAd.  # noqa: E501

        <div lang=\"ja\">トラッキングURLです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。<br> finalUrlを指定するときのみ、任意で指定できます。<br> ※現在利用できません </div> <div lang=\"en\">Tracking URL.<br> This field will be returned in the response, it will be ignored on input.<br> This field can be optionally specified only when specifying finalUrl.<br> * Not Available. </div>   # noqa: E501

        :return: The tracking_url of this GuaranteedAdGroupAdServiceCarouselAd.  # noqa: E501
        :rtype: str
        """
        return self._tracking_url

    @tracking_url.setter
    def tracking_url(self, tracking_url):
        """Sets the tracking_url of this GuaranteedAdGroupAdServiceCarouselAd.

        <div lang=\"ja\">トラッキングURLです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。<br> finalUrlを指定するときのみ、任意で指定できます。<br> ※現在利用できません </div> <div lang=\"en\">Tracking URL.<br> This field will be returned in the response, it will be ignored on input.<br> This field can be optionally specified only when specifying finalUrl.<br> * Not Available. </div>   # noqa: E501

        :param tracking_url: The tracking_url of this GuaranteedAdGroupAdServiceCarouselAd.  # noqa: E501
        :type: str
        """

        self._tracking_url = tracking_url

    @property
    def carousels(self):
        """Gets the carousels of this GuaranteedAdGroupAdServiceCarouselAd.  # noqa: E501


        :return: The carousels of this GuaranteedAdGroupAdServiceCarouselAd.  # noqa: E501
        :rtype: list[GuaranteedAdGroupAdServiceCarousel]
        """
        return self._carousels

    @carousels.setter
    def carousels(self, carousels):
        """Sets the carousels of this GuaranteedAdGroupAdServiceCarouselAd.


        :param carousels: The carousels of this GuaranteedAdGroupAdServiceCarouselAd.  # noqa: E501
        :type: list[GuaranteedAdGroupAdServiceCarousel]
        """

        self._carousels = carousels

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GuaranteedAdGroupAdServiceCarouselAd):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GuaranteedAdGroupAdServiceCarouselAd):
            return True

        return self.to_dict() != other.to_dict()
