# coding: utf-8

"""
    Yahoo!広告 ディスプレイ広告 API リファレンス / Yahoo! JAPAN Ads Display Ads API Reference

    <div lang=\"ja\">Yahoo!広告 ディスプレイ広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Display Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/design/v12/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v12
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_display_test.configuration import Configuration


class GuaranteedAdGroupAdServiceInstreamAd(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'display_url': 'str',
        'custom_parameters': 'GuaranteedAdGroupAdServiceCustomParameters',
        'display_url_level': 'GuaranteedAdGroupAdServiceDisplayUrlLevel',
        'final_url': 'str',
        'smartphone_final_url': 'str',
        'tracking_url': 'str',
        'headline': 'str',
        'video25_percent_beacon_urls': 'list[str]',
        'video50_percent_beacon_urls': 'list[str]',
        'video75_percent_beacon_urls': 'list[str]',
        'video_complete_beacon_urls': 'list[str]',
        'video_start_beacon_urls': 'list[str]',
        'action_after_ad_clicks': 'bool'
    }

    attribute_map = {
        'display_url': 'displayUrl',
        'custom_parameters': 'customParameters',
        'display_url_level': 'displayUrlLevel',
        'final_url': 'finalUrl',
        'smartphone_final_url': 'smartphoneFinalUrl',
        'tracking_url': 'trackingUrl',
        'headline': 'headline',
        'video25_percent_beacon_urls': 'video25PercentBeaconUrls',
        'video50_percent_beacon_urls': 'video50PercentBeaconUrls',
        'video75_percent_beacon_urls': 'video75PercentBeaconUrls',
        'video_complete_beacon_urls': 'videoCompleteBeaconUrls',
        'video_start_beacon_urls': 'videoStartBeaconUrls',
        'action_after_ad_clicks': 'actionAfterAdClicks'
    }

    def __init__(self, display_url=None, custom_parameters=None, display_url_level=None, final_url=None, smartphone_final_url=None, tracking_url=None, headline=None, video25_percent_beacon_urls=None, video50_percent_beacon_urls=None, video75_percent_beacon_urls=None, video_complete_beacon_urls=None, video_start_beacon_urls=None, action_after_ad_clicks=None, local_vars_configuration=None):  # noqa: E501
        """GuaranteedAdGroupAdServiceInstreamAd - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._display_url = None
        self._custom_parameters = None
        self._display_url_level = None
        self._final_url = None
        self._smartphone_final_url = None
        self._tracking_url = None
        self._headline = None
        self._video25_percent_beacon_urls = None
        self._video50_percent_beacon_urls = None
        self._video75_percent_beacon_urls = None
        self._video_complete_beacon_urls = None
        self._video_start_beacon_urls = None
        self._action_after_ad_clicks = None
        self.discriminator = None

        self.display_url = display_url
        self.custom_parameters = custom_parameters
        self.display_url_level = display_url_level
        self.final_url = final_url
        self.smartphone_final_url = smartphone_final_url
        self.tracking_url = tracking_url
        self.headline = headline
        self.video25_percent_beacon_urls = video25_percent_beacon_urls
        self.video50_percent_beacon_urls = video50_percent_beacon_urls
        self.video75_percent_beacon_urls = video75_percent_beacon_urls
        self.video_complete_beacon_urls = video_complete_beacon_urls
        self.video_start_beacon_urls = video_start_beacon_urls
        self.action_after_ad_clicks = action_after_ad_clicks

    @property
    def display_url(self):
        """Gets the display_url of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501

        <div lang=\"ja\"> 表示URLです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Display URL.<br> This field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :return: The display_url of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501
        :rtype: str
        """
        return self._display_url

    @display_url.setter
    def display_url(self, display_url):
        """Sets the display_url of this GuaranteedAdGroupAdServiceInstreamAd.

        <div lang=\"ja\"> 表示URLです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Display URL.<br> This field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :param display_url: The display_url of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501
        :type: str
        """

        self._display_url = display_url

    @property
    def custom_parameters(self):
        """Gets the custom_parameters of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501


        :return: The custom_parameters of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501
        :rtype: GuaranteedAdGroupAdServiceCustomParameters
        """
        return self._custom_parameters

    @custom_parameters.setter
    def custom_parameters(self, custom_parameters):
        """Sets the custom_parameters of this GuaranteedAdGroupAdServiceInstreamAd.


        :param custom_parameters: The custom_parameters of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501
        :type: GuaranteedAdGroupAdServiceCustomParameters
        """

        self._custom_parameters = custom_parameters

    @property
    def display_url_level(self):
        """Gets the display_url_level of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501


        :return: The display_url_level of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501
        :rtype: GuaranteedAdGroupAdServiceDisplayUrlLevel
        """
        return self._display_url_level

    @display_url_level.setter
    def display_url_level(self, display_url_level):
        """Sets the display_url_level of this GuaranteedAdGroupAdServiceInstreamAd.


        :param display_url_level: The display_url_level of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501
        :type: GuaranteedAdGroupAdServiceDisplayUrlLevel
        """

        self._display_url_level = display_url_level

    @property
    def final_url(self):
        """Gets the final_url of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501

        <div lang=\"ja\">最終リンク先URLです。<br> finalUrlフィールドを設定する場合、trackingUrl、customParametersは任意になります。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。<br> ※actionAfterAdClicksがtrueの場合は必須です。 </div> <div lang=\"en\">Final URL.<br> If you specify finalUrl, trackingUrl and customParameters will be optional.<br> This field will be returned in the response, it will be ignored on input.<br> ∗If actionAfterAdClicks is true, this field is required. </div>   # noqa: E501

        :return: The final_url of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501
        :rtype: str
        """
        return self._final_url

    @final_url.setter
    def final_url(self, final_url):
        """Sets the final_url of this GuaranteedAdGroupAdServiceInstreamAd.

        <div lang=\"ja\">最終リンク先URLです。<br> finalUrlフィールドを設定する場合、trackingUrl、customParametersは任意になります。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。<br> ※actionAfterAdClicksがtrueの場合は必須です。 </div> <div lang=\"en\">Final URL.<br> If you specify finalUrl, trackingUrl and customParameters will be optional.<br> This field will be returned in the response, it will be ignored on input.<br> ∗If actionAfterAdClicks is true, this field is required. </div>   # noqa: E501

        :param final_url: The final_url of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501
        :type: str
        """

        self._final_url = final_url

    @property
    def smartphone_final_url(self):
        """Gets the smartphone_final_url of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501

        <div lang=\"ja\">スマートフォン向けURLです。<br> finalUrlを指定するときのみ、任意で指定できます。 </div> <div lang=\"en\">Final URL (smartphone).<br> This field can be optionally specified only when specifying finalUrl. </div>   # noqa: E501

        :return: The smartphone_final_url of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501
        :rtype: str
        """
        return self._smartphone_final_url

    @smartphone_final_url.setter
    def smartphone_final_url(self, smartphone_final_url):
        """Sets the smartphone_final_url of this GuaranteedAdGroupAdServiceInstreamAd.

        <div lang=\"ja\">スマートフォン向けURLです。<br> finalUrlを指定するときのみ、任意で指定できます。 </div> <div lang=\"en\">Final URL (smartphone).<br> This field can be optionally specified only when specifying finalUrl. </div>   # noqa: E501

        :param smartphone_final_url: The smartphone_final_url of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501
        :type: str
        """

        self._smartphone_final_url = smartphone_final_url

    @property
    def tracking_url(self):
        """Gets the tracking_url of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501

        <div lang=\"ja\">トラッキングURLです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。<br> finalUrlを指定するときのみ、任意で指定できます。 </div> <div lang=\"en\">Tracking URL.<br> This field will be returned in the response, it will be ignored on input.<br> This field can be optionally specified only when specifying finalUrl. </div>   # noqa: E501

        :return: The tracking_url of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501
        :rtype: str
        """
        return self._tracking_url

    @tracking_url.setter
    def tracking_url(self, tracking_url):
        """Sets the tracking_url of this GuaranteedAdGroupAdServiceInstreamAd.

        <div lang=\"ja\">トラッキングURLです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。<br> finalUrlを指定するときのみ、任意で指定できます。 </div> <div lang=\"en\">Tracking URL.<br> This field will be returned in the response, it will be ignored on input.<br> This field can be optionally specified only when specifying finalUrl. </div>   # noqa: E501

        :param tracking_url: The tracking_url of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501
        :type: str
        """

        self._tracking_url = tracking_url

    @property
    def headline(self):
        """Gets the headline of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501

        <div lang=\"ja\"> ヘッドラインです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Headline.<br> This field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :return: The headline of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501
        :rtype: str
        """
        return self._headline

    @headline.setter
    def headline(self, headline):
        """Sets the headline of this GuaranteedAdGroupAdServiceInstreamAd.

        <div lang=\"ja\"> ヘッドラインです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Headline.<br> This field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :param headline: The headline of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501
        :type: str
        """

        self._headline = headline

    @property
    def video25_percent_beacon_urls(self):
        """Gets the video25_percent_beacon_urls of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501

        <div lang=\"ja\"> 25％再生視聴ビーコンURLです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。<br> ※httpsのURLのみ設定可能です。 </div> <div lang=\"en\"> Playback viewing beacon URL (25%).<br> This field will be returned in the response, it will be ignored on input.<br> ∗Available URL is only &#34;https&#34;. </div>   # noqa: E501

        :return: The video25_percent_beacon_urls of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501
        :rtype: list[str]
        """
        return self._video25_percent_beacon_urls

    @video25_percent_beacon_urls.setter
    def video25_percent_beacon_urls(self, video25_percent_beacon_urls):
        """Sets the video25_percent_beacon_urls of this GuaranteedAdGroupAdServiceInstreamAd.

        <div lang=\"ja\"> 25％再生視聴ビーコンURLです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。<br> ※httpsのURLのみ設定可能です。 </div> <div lang=\"en\"> Playback viewing beacon URL (25%).<br> This field will be returned in the response, it will be ignored on input.<br> ∗Available URL is only &#34;https&#34;. </div>   # noqa: E501

        :param video25_percent_beacon_urls: The video25_percent_beacon_urls of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501
        :type: list[str]
        """

        self._video25_percent_beacon_urls = video25_percent_beacon_urls

    @property
    def video50_percent_beacon_urls(self):
        """Gets the video50_percent_beacon_urls of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501

        <div lang=\"ja\"> 50％再生視聴ビーコンURLです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。<br> ※httpsのURLのみ設定可能です。 </div> <div lang=\"en\"> Playback viewing beacon URL (50%).<br> This field will be returned in the response, it will be ignored on input.<br> ∗Available URL is only &#34;https&#34;. </div>   # noqa: E501

        :return: The video50_percent_beacon_urls of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501
        :rtype: list[str]
        """
        return self._video50_percent_beacon_urls

    @video50_percent_beacon_urls.setter
    def video50_percent_beacon_urls(self, video50_percent_beacon_urls):
        """Sets the video50_percent_beacon_urls of this GuaranteedAdGroupAdServiceInstreamAd.

        <div lang=\"ja\"> 50％再生視聴ビーコンURLです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。<br> ※httpsのURLのみ設定可能です。 </div> <div lang=\"en\"> Playback viewing beacon URL (50%).<br> This field will be returned in the response, it will be ignored on input.<br> ∗Available URL is only &#34;https&#34;. </div>   # noqa: E501

        :param video50_percent_beacon_urls: The video50_percent_beacon_urls of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501
        :type: list[str]
        """

        self._video50_percent_beacon_urls = video50_percent_beacon_urls

    @property
    def video75_percent_beacon_urls(self):
        """Gets the video75_percent_beacon_urls of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501

        <div lang=\"ja\"> 75％再生視聴ビーコンURLです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。<br> ※httpsのURLのみ設定可能です。 </div> <div lang=\"en\"> Playback viewing beacon URL (75%).<br> This field will be returned in the response, it will be ignored on input.<br> ∗Available URL is only &#34;https&#34;. </div>   # noqa: E501

        :return: The video75_percent_beacon_urls of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501
        :rtype: list[str]
        """
        return self._video75_percent_beacon_urls

    @video75_percent_beacon_urls.setter
    def video75_percent_beacon_urls(self, video75_percent_beacon_urls):
        """Sets the video75_percent_beacon_urls of this GuaranteedAdGroupAdServiceInstreamAd.

        <div lang=\"ja\"> 75％再生視聴ビーコンURLです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。<br> ※httpsのURLのみ設定可能です。 </div> <div lang=\"en\"> Playback viewing beacon URL (75%).<br> This field will be returned in the response, it will be ignored on input.<br> ∗Available URL is only &#34;https&#34;. </div>   # noqa: E501

        :param video75_percent_beacon_urls: The video75_percent_beacon_urls of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501
        :type: list[str]
        """

        self._video75_percent_beacon_urls = video75_percent_beacon_urls

    @property
    def video_complete_beacon_urls(self):
        """Gets the video_complete_beacon_urls of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501

        <div lang=\"ja\"> 再生完了ビーコンURLです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。<br> ※httpsのURLのみ設定可能です。 </div> <div lang=\"en\"> Viewing beacon URL (complete).<br> This field will be returned in the response, it will be ignored on input.<br> ∗Available URL is only &#34;https&#34;. </div>   # noqa: E501

        :return: The video_complete_beacon_urls of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501
        :rtype: list[str]
        """
        return self._video_complete_beacon_urls

    @video_complete_beacon_urls.setter
    def video_complete_beacon_urls(self, video_complete_beacon_urls):
        """Sets the video_complete_beacon_urls of this GuaranteedAdGroupAdServiceInstreamAd.

        <div lang=\"ja\"> 再生完了ビーコンURLです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。<br> ※httpsのURLのみ設定可能です。 </div> <div lang=\"en\"> Viewing beacon URL (complete).<br> This field will be returned in the response, it will be ignored on input.<br> ∗Available URL is only &#34;https&#34;. </div>   # noqa: E501

        :param video_complete_beacon_urls: The video_complete_beacon_urls of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501
        :type: list[str]
        """

        self._video_complete_beacon_urls = video_complete_beacon_urls

    @property
    def video_start_beacon_urls(self):
        """Gets the video_start_beacon_urls of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501

        <div lang=\"ja\"> 再生開始ビーコンURLです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。<br> ※httpsのURLのみ設定可能です。 </div> <div lang=\"en\"> Viewing beacon URL (start).<br> This field will be returned in the response, it will be ignored on input.<br> ∗Available URL is only &#34;https&#34;. </div>   # noqa: E501

        :return: The video_start_beacon_urls of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501
        :rtype: list[str]
        """
        return self._video_start_beacon_urls

    @video_start_beacon_urls.setter
    def video_start_beacon_urls(self, video_start_beacon_urls):
        """Sets the video_start_beacon_urls of this GuaranteedAdGroupAdServiceInstreamAd.

        <div lang=\"ja\"> 再生開始ビーコンURLです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。<br> ※httpsのURLのみ設定可能です。 </div> <div lang=\"en\"> Viewing beacon URL (start).<br> This field will be returned in the response, it will be ignored on input.<br> ∗Available URL is only &#34;https&#34;. </div>   # noqa: E501

        :param video_start_beacon_urls: The video_start_beacon_urls of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501
        :type: list[str]
        """

        self._video_start_beacon_urls = video_start_beacon_urls

    @property
    def action_after_ad_clicks(self):
        """Gets the action_after_ad_clicks of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501

        <div lang=\"ja\"> 広告クリック時の動作です。trueの場合は、最終リンク先URLへ遷移します。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Behavior when clicked on the ad. If true, it will transition to the final URL.<br> This field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :return: The action_after_ad_clicks of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501
        :rtype: bool
        """
        return self._action_after_ad_clicks

    @action_after_ad_clicks.setter
    def action_after_ad_clicks(self, action_after_ad_clicks):
        """Sets the action_after_ad_clicks of this GuaranteedAdGroupAdServiceInstreamAd.

        <div lang=\"ja\"> 広告クリック時の動作です。trueの場合は、最終リンク先URLへ遷移します。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Behavior when clicked on the ad. If true, it will transition to the final URL.<br> This field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :param action_after_ad_clicks: The action_after_ad_clicks of this GuaranteedAdGroupAdServiceInstreamAd.  # noqa: E501
        :type: bool
        """

        self._action_after_ad_clicks = action_after_ad_clicks

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GuaranteedAdGroupAdServiceInstreamAd):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GuaranteedAdGroupAdServiceInstreamAd):
            return True

        return self.to_dict() != other.to_dict()
