# coding: utf-8

"""
    Yahoo!広告 ディスプレイ広告 API リファレンス / Yahoo! JAPAN Ads Display Ads API Reference

    <div lang=\"ja\">Yahoo!広告 ディスプレイ広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Display Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/design/v12/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v12
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_display_test.configuration import Configuration


class GuaranteedCampaign(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'account_id': 'int',
        'lifetime_budget': 'GuaranteedCampaignServiceLifetimeBudget',
        'campaign_bidding_strategy': 'GuaranteedCampaignServiceCampaignBiddingStrategy',
        'campaign_goal': 'str',
        'campaign_id': 'int',
        'campaign_name': 'str',
        'end_date': 'str',
        'end_time': 'str',
        'labels': 'list[GuaranteedCampaignServiceLabel]',
        'serving_status': 'GuaranteedCampaignServiceServingStatus',
        'start_date': 'str',
        'start_time': 'str',
        'user_status': 'GuaranteedCampaignServiceUserStatus',
        'viewable_frequency_cap': 'GuaranteedCampaignServiceViewableFrequencyCap',
        'guaranteed_simulation_id': 'int',
        'notification_email_address': 'list[str]',
        'ad_category_status': 'GuaranteedCampaignServiceAdCategoryStatus',
        'campaign_canceled_date': 'str',
        'package': 'GuaranteedCampaignServicePackage',
        'brand_tracking': 'GuaranteedCampaignServiceBrandTracking',
        'conversion_tracker': 'GuaranteedCampaignServiceConversionTracker'
    }

    attribute_map = {
        'account_id': 'accountId',
        'lifetime_budget': 'lifetimeBudget',
        'campaign_bidding_strategy': 'campaignBiddingStrategy',
        'campaign_goal': 'campaignGoal',
        'campaign_id': 'campaignId',
        'campaign_name': 'campaignName',
        'end_date': 'endDate',
        'end_time': 'endTime',
        'labels': 'labels',
        'serving_status': 'servingStatus',
        'start_date': 'startDate',
        'start_time': 'startTime',
        'user_status': 'userStatus',
        'viewable_frequency_cap': 'viewableFrequencyCap',
        'guaranteed_simulation_id': 'guaranteedSimulationId',
        'notification_email_address': 'notificationEmailAddress',
        'ad_category_status': 'adCategoryStatus',
        'campaign_canceled_date': 'campaignCanceledDate',
        'package': 'package',
        'brand_tracking': 'brandTracking',
        'conversion_tracker': 'conversionTracker'
    }

    def __init__(self, account_id=None, lifetime_budget=None, campaign_bidding_strategy=None, campaign_goal=None, campaign_id=None, campaign_name=None, end_date=None, end_time=None, labels=None, serving_status=None, start_date=None, start_time=None, user_status=None, viewable_frequency_cap=None, guaranteed_simulation_id=None, notification_email_address=None, ad_category_status=None, campaign_canceled_date=None, package=None, brand_tracking=None, conversion_tracker=None, local_vars_configuration=None):  # noqa: E501
        """GuaranteedCampaign - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._account_id = None
        self._lifetime_budget = None
        self._campaign_bidding_strategy = None
        self._campaign_goal = None
        self._campaign_id = None
        self._campaign_name = None
        self._end_date = None
        self._end_time = None
        self._labels = None
        self._serving_status = None
        self._start_date = None
        self._start_time = None
        self._user_status = None
        self._viewable_frequency_cap = None
        self._guaranteed_simulation_id = None
        self._notification_email_address = None
        self._ad_category_status = None
        self._campaign_canceled_date = None
        self._package = None
        self._brand_tracking = None
        self._conversion_tracker = None
        self.discriminator = None

        self.account_id = account_id
        self.lifetime_budget = lifetime_budget
        self.campaign_bidding_strategy = campaign_bidding_strategy
        self.campaign_goal = campaign_goal
        self.campaign_id = campaign_id
        self.campaign_name = campaign_name
        self.end_date = end_date
        self.end_time = end_time
        self.labels = labels
        self.serving_status = serving_status
        self.start_date = start_date
        self.start_time = start_time
        self.user_status = user_status
        self.viewable_frequency_cap = viewable_frequency_cap
        self.guaranteed_simulation_id = guaranteed_simulation_id
        self.notification_email_address = notification_email_address
        self.ad_category_status = ad_category_status
        self.campaign_canceled_date = campaign_canceled_date
        self.package = package
        self.brand_tracking = brand_tracking
        self.conversion_tracker = conversion_tracker

    @property
    def account_id(self):
        """Gets the account_id of this GuaranteedCampaign.  # noqa: E501

        <div lang=\"ja\"> アカウントIDです。<br> このフィールドは、リクエストの場合は必須です。 </div> <div lang=\"en\"> Account ID. <br> This field is required in requests. </div>   # noqa: E501

        :return: The account_id of this GuaranteedCampaign.  # noqa: E501
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this GuaranteedCampaign.

        <div lang=\"ja\"> アカウントIDです。<br> このフィールドは、リクエストの場合は必須です。 </div> <div lang=\"en\"> Account ID. <br> This field is required in requests. </div>   # noqa: E501

        :param account_id: The account_id of this GuaranteedCampaign.  # noqa: E501
        :type: int
        """

        self._account_id = account_id

    @property
    def lifetime_budget(self):
        """Gets the lifetime_budget of this GuaranteedCampaign.  # noqa: E501


        :return: The lifetime_budget of this GuaranteedCampaign.  # noqa: E501
        :rtype: GuaranteedCampaignServiceLifetimeBudget
        """
        return self._lifetime_budget

    @lifetime_budget.setter
    def lifetime_budget(self, lifetime_budget):
        """Sets the lifetime_budget of this GuaranteedCampaign.


        :param lifetime_budget: The lifetime_budget of this GuaranteedCampaign.  # noqa: E501
        :type: GuaranteedCampaignServiceLifetimeBudget
        """

        self._lifetime_budget = lifetime_budget

    @property
    def campaign_bidding_strategy(self):
        """Gets the campaign_bidding_strategy of this GuaranteedCampaign.  # noqa: E501


        :return: The campaign_bidding_strategy of this GuaranteedCampaign.  # noqa: E501
        :rtype: GuaranteedCampaignServiceCampaignBiddingStrategy
        """
        return self._campaign_bidding_strategy

    @campaign_bidding_strategy.setter
    def campaign_bidding_strategy(self, campaign_bidding_strategy):
        """Sets the campaign_bidding_strategy of this GuaranteedCampaign.


        :param campaign_bidding_strategy: The campaign_bidding_strategy of this GuaranteedCampaign.  # noqa: E501
        :type: GuaranteedCampaignServiceCampaignBiddingStrategy
        """

        self._campaign_bidding_strategy = campaign_bidding_strategy

    @property
    def campaign_goal(self):
        """Gets the campaign_goal of this GuaranteedCampaign.  # noqa: E501

        <div lang=\"ja\"> キャンペーン目的です。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Campaign goal.<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :return: The campaign_goal of this GuaranteedCampaign.  # noqa: E501
        :rtype: str
        """
        return self._campaign_goal

    @campaign_goal.setter
    def campaign_goal(self, campaign_goal):
        """Sets the campaign_goal of this GuaranteedCampaign.

        <div lang=\"ja\"> キャンペーン目的です。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Campaign goal.<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :param campaign_goal: The campaign_goal of this GuaranteedCampaign.  # noqa: E501
        :type: str
        """

        self._campaign_goal = campaign_goal

    @property
    def campaign_id(self):
        """Gets the campaign_id of this GuaranteedCampaign.  # noqa: E501

        <div lang=\"ja\"> キャンペーンIDです。<br> このフィールドはSET時に必須となります。 </div> <div lang=\"en\"> Campaign ID.<br> This field is required in SET operation. </div>   # noqa: E501

        :return: The campaign_id of this GuaranteedCampaign.  # noqa: E501
        :rtype: int
        """
        return self._campaign_id

    @campaign_id.setter
    def campaign_id(self, campaign_id):
        """Sets the campaign_id of this GuaranteedCampaign.

        <div lang=\"ja\"> キャンペーンIDです。<br> このフィールドはSET時に必須となります。 </div> <div lang=\"en\"> Campaign ID.<br> This field is required in SET operation. </div>   # noqa: E501

        :param campaign_id: The campaign_id of this GuaranteedCampaign.  # noqa: E501
        :type: int
        """

        self._campaign_id = campaign_id

    @property
    def campaign_name(self):
        """Gets the campaign_name of this GuaranteedCampaign.  # noqa: E501

        <div lang=\"ja\"> キャンペーン名です。 </div> <div lang=\"en\"> Campaign name. </div>   # noqa: E501

        :return: The campaign_name of this GuaranteedCampaign.  # noqa: E501
        :rtype: str
        """
        return self._campaign_name

    @campaign_name.setter
    def campaign_name(self, campaign_name):
        """Sets the campaign_name of this GuaranteedCampaign.

        <div lang=\"ja\"> キャンペーン名です。 </div> <div lang=\"en\"> Campaign name. </div>   # noqa: E501

        :param campaign_name: The campaign_name of this GuaranteedCampaign.  # noqa: E501
        :type: str
        """

        self._campaign_name = campaign_name

    @property
    def end_date(self):
        """Gets the end_date of this GuaranteedCampaign.  # noqa: E501

        <div lang=\"ja\"> 終了日です。<br> ※フォーマット：yyyyMMdd<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> End date.<br> ∗ Format: yyyyMMdd<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :return: The end_date of this GuaranteedCampaign.  # noqa: E501
        :rtype: str
        """
        return self._end_date

    @end_date.setter
    def end_date(self, end_date):
        """Sets the end_date of this GuaranteedCampaign.

        <div lang=\"ja\"> 終了日です。<br> ※フォーマット：yyyyMMdd<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> End date.<br> ∗ Format: yyyyMMdd<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :param end_date: The end_date of this GuaranteedCampaign.  # noqa: E501
        :type: str
        """

        self._end_date = end_date

    @property
    def end_time(self):
        """Gets the end_time of this GuaranteedCampaign.  # noqa: E501

        <div lang=\"ja\"> 終了時刻です。<br> ※フォーマット：HHmm<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> End time.<br> * Format: HHmm<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :return: The end_time of this GuaranteedCampaign.  # noqa: E501
        :rtype: str
        """
        return self._end_time

    @end_time.setter
    def end_time(self, end_time):
        """Sets the end_time of this GuaranteedCampaign.

        <div lang=\"ja\"> 終了時刻です。<br> ※フォーマット：HHmm<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> End time.<br> * Format: HHmm<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :param end_time: The end_time of this GuaranteedCampaign.  # noqa: E501
        :type: str
        """

        self._end_time = end_time

    @property
    def labels(self):
        """Gets the labels of this GuaranteedCampaign.  # noqa: E501


        :return: The labels of this GuaranteedCampaign.  # noqa: E501
        :rtype: list[GuaranteedCampaignServiceLabel]
        """
        return self._labels

    @labels.setter
    def labels(self, labels):
        """Sets the labels of this GuaranteedCampaign.


        :param labels: The labels of this GuaranteedCampaign.  # noqa: E501
        :type: list[GuaranteedCampaignServiceLabel]
        """

        self._labels = labels

    @property
    def serving_status(self):
        """Gets the serving_status of this GuaranteedCampaign.  # noqa: E501


        :return: The serving_status of this GuaranteedCampaign.  # noqa: E501
        :rtype: GuaranteedCampaignServiceServingStatus
        """
        return self._serving_status

    @serving_status.setter
    def serving_status(self, serving_status):
        """Sets the serving_status of this GuaranteedCampaign.


        :param serving_status: The serving_status of this GuaranteedCampaign.  # noqa: E501
        :type: GuaranteedCampaignServiceServingStatus
        """

        self._serving_status = serving_status

    @property
    def start_date(self):
        """Gets the start_date of this GuaranteedCampaign.  # noqa: E501

        <div lang=\"ja\"> 開始日です。<br> ※フォーマット：yyyyMMdd<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Start date.<br> ∗ Format: yyyyMMdd<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :return: The start_date of this GuaranteedCampaign.  # noqa: E501
        :rtype: str
        """
        return self._start_date

    @start_date.setter
    def start_date(self, start_date):
        """Sets the start_date of this GuaranteedCampaign.

        <div lang=\"ja\"> 開始日です。<br> ※フォーマット：yyyyMMdd<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Start date.<br> ∗ Format: yyyyMMdd<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :param start_date: The start_date of this GuaranteedCampaign.  # noqa: E501
        :type: str
        """

        self._start_date = start_date

    @property
    def start_time(self):
        """Gets the start_time of this GuaranteedCampaign.  # noqa: E501

        <div lang=\"ja\"> 開始時刻です。<br> ※フォーマット：HHmm<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Start time.<br> * Format: HHmm<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :return: The start_time of this GuaranteedCampaign.  # noqa: E501
        :rtype: str
        """
        return self._start_time

    @start_time.setter
    def start_time(self, start_time):
        """Sets the start_time of this GuaranteedCampaign.

        <div lang=\"ja\"> 開始時刻です。<br> ※フォーマット：HHmm<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Start time.<br> * Format: HHmm<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :param start_time: The start_time of this GuaranteedCampaign.  # noqa: E501
        :type: str
        """

        self._start_time = start_time

    @property
    def user_status(self):
        """Gets the user_status of this GuaranteedCampaign.  # noqa: E501


        :return: The user_status of this GuaranteedCampaign.  # noqa: E501
        :rtype: GuaranteedCampaignServiceUserStatus
        """
        return self._user_status

    @user_status.setter
    def user_status(self, user_status):
        """Sets the user_status of this GuaranteedCampaign.


        :param user_status: The user_status of this GuaranteedCampaign.  # noqa: E501
        :type: GuaranteedCampaignServiceUserStatus
        """

        self._user_status = user_status

    @property
    def viewable_frequency_cap(self):
        """Gets the viewable_frequency_cap of this GuaranteedCampaign.  # noqa: E501


        :return: The viewable_frequency_cap of this GuaranteedCampaign.  # noqa: E501
        :rtype: GuaranteedCampaignServiceViewableFrequencyCap
        """
        return self._viewable_frequency_cap

    @viewable_frequency_cap.setter
    def viewable_frequency_cap(self, viewable_frequency_cap):
        """Sets the viewable_frequency_cap of this GuaranteedCampaign.


        :param viewable_frequency_cap: The viewable_frequency_cap of this GuaranteedCampaign.  # noqa: E501
        :type: GuaranteedCampaignServiceViewableFrequencyCap
        """

        self._viewable_frequency_cap = viewable_frequency_cap

    @property
    def guaranteed_simulation_id(self):
        """Gets the guaranteed_simulation_id of this GuaranteedCampaign.  # noqa: E501

        <div lang=\"ja\"> シミュレーションIDです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Simulation ID.<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :return: The guaranteed_simulation_id of this GuaranteedCampaign.  # noqa: E501
        :rtype: int
        """
        return self._guaranteed_simulation_id

    @guaranteed_simulation_id.setter
    def guaranteed_simulation_id(self, guaranteed_simulation_id):
        """Sets the guaranteed_simulation_id of this GuaranteedCampaign.

        <div lang=\"ja\"> シミュレーションIDです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> Simulation ID.<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :param guaranteed_simulation_id: The guaranteed_simulation_id of this GuaranteedCampaign.  # noqa: E501
        :type: int
        """

        self._guaranteed_simulation_id = guaranteed_simulation_id

    @property
    def notification_email_address(self):
        """Gets the notification_email_address of this GuaranteedCampaign.  # noqa: E501

        <div lang=\"ja\"> 連絡先メールアドレスです。<br> </div> <div lang=\"en\"> Email address to send notifications.<br> </div>   # noqa: E501

        :return: The notification_email_address of this GuaranteedCampaign.  # noqa: E501
        :rtype: list[str]
        """
        return self._notification_email_address

    @notification_email_address.setter
    def notification_email_address(self, notification_email_address):
        """Sets the notification_email_address of this GuaranteedCampaign.

        <div lang=\"ja\"> 連絡先メールアドレスです。<br> </div> <div lang=\"en\"> Email address to send notifications.<br> </div>   # noqa: E501

        :param notification_email_address: The notification_email_address of this GuaranteedCampaign.  # noqa: E501
        :type: list[str]
        """

        self._notification_email_address = notification_email_address

    @property
    def ad_category_status(self):
        """Gets the ad_category_status of this GuaranteedCampaign.  # noqa: E501


        :return: The ad_category_status of this GuaranteedCampaign.  # noqa: E501
        :rtype: GuaranteedCampaignServiceAdCategoryStatus
        """
        return self._ad_category_status

    @ad_category_status.setter
    def ad_category_status(self, ad_category_status):
        """Sets the ad_category_status of this GuaranteedCampaign.


        :param ad_category_status: The ad_category_status of this GuaranteedCampaign.  # noqa: E501
        :type: GuaranteedCampaignServiceAdCategoryStatus
        """

        self._ad_category_status = ad_category_status

    @property
    def campaign_canceled_date(self):
        """Gets the campaign_canceled_date of this GuaranteedCampaign.  # noqa: E501

        <div lang=\"ja\"> 予約型のキャンペーンをキャンセルした日時です。<br> ※フォーマット：yyyyMMddHHmmss<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> A date and time which the guaranteed campaign is cancelled.<br> ∗ Format: yyyyMMddHHmmss<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :return: The campaign_canceled_date of this GuaranteedCampaign.  # noqa: E501
        :rtype: str
        """
        return self._campaign_canceled_date

    @campaign_canceled_date.setter
    def campaign_canceled_date(self, campaign_canceled_date):
        """Sets the campaign_canceled_date of this GuaranteedCampaign.

        <div lang=\"ja\"> 予約型のキャンペーンをキャンセルした日時です。<br> ※フォーマット：yyyyMMddHHmmss<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> A date and time which the guaranteed campaign is cancelled.<br> ∗ Format: yyyyMMddHHmmss<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :param campaign_canceled_date: The campaign_canceled_date of this GuaranteedCampaign.  # noqa: E501
        :type: str
        """

        self._campaign_canceled_date = campaign_canceled_date

    @property
    def package(self):
        """Gets the package of this GuaranteedCampaign.  # noqa: E501


        :return: The package of this GuaranteedCampaign.  # noqa: E501
        :rtype: GuaranteedCampaignServicePackage
        """
        return self._package

    @package.setter
    def package(self, package):
        """Sets the package of this GuaranteedCampaign.


        :param package: The package of this GuaranteedCampaign.  # noqa: E501
        :type: GuaranteedCampaignServicePackage
        """

        self._package = package

    @property
    def brand_tracking(self):
        """Gets the brand_tracking of this GuaranteedCampaign.  # noqa: E501


        :return: The brand_tracking of this GuaranteedCampaign.  # noqa: E501
        :rtype: GuaranteedCampaignServiceBrandTracking
        """
        return self._brand_tracking

    @brand_tracking.setter
    def brand_tracking(self, brand_tracking):
        """Sets the brand_tracking of this GuaranteedCampaign.


        :param brand_tracking: The brand_tracking of this GuaranteedCampaign.  # noqa: E501
        :type: GuaranteedCampaignServiceBrandTracking
        """

        self._brand_tracking = brand_tracking

    @property
    def conversion_tracker(self):
        """Gets the conversion_tracker of this GuaranteedCampaign.  # noqa: E501


        :return: The conversion_tracker of this GuaranteedCampaign.  # noqa: E501
        :rtype: GuaranteedCampaignServiceConversionTracker
        """
        return self._conversion_tracker

    @conversion_tracker.setter
    def conversion_tracker(self, conversion_tracker):
        """Sets the conversion_tracker of this GuaranteedCampaign.


        :param conversion_tracker: The conversion_tracker of this GuaranteedCampaign.  # noqa: E501
        :type: GuaranteedCampaignServiceConversionTracker
        """

        self._conversion_tracker = conversion_tracker

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GuaranteedCampaign):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GuaranteedCampaign):
            return True

        return self.to_dict() != other.to_dict()
