# coding: utf-8

"""
    Yahoo!広告 ディスプレイ広告 API リファレンス / Yahoo! JAPAN Ads Display Ads API Reference

    <div lang=\"ja\">Yahoo!広告 ディスプレイ広告 APIのWebサービスについて説明します。</div> <div lang=\"en\">Display Ads API Web Services supported in Yahoo! JAPAN Ads API.</div> <div><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/design/v12/Route.yaml\">OpenAPI Specification</a></div> <div lang=\"ja\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/ja\">Best Practice</a></div> <div lang=\"en\"><a target=\"_blank\" href=\"https://github.com/yahoojp-marketing/ads-display-api-documents/blob/master/bestpractice/en\">Best Practice</a></div>   # noqa: E501

    The version of the OpenAPI document: v12
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_display_test.configuration import Configuration


class RetargetingTag(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'account_id': 'int',
        'approval_status': 'RetargetingTagServiceApprovalStatus',
        'retargeting_tag_id': 'str',
        'advanced_tag': 'str'
    }

    attribute_map = {
        'account_id': 'accountId',
        'approval_status': 'approvalStatus',
        'retargeting_tag_id': 'retargetingTagId',
        'advanced_tag': 'advancedTag'
    }

    def __init__(self, account_id=None, approval_status=None, retargeting_tag_id=None, advanced_tag=None, local_vars_configuration=None):  # noqa: E501
        """RetargetingTag - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._account_id = None
        self._approval_status = None
        self._retargeting_tag_id = None
        self._advanced_tag = None
        self.discriminator = None

        self.account_id = account_id
        self.approval_status = approval_status
        self.retargeting_tag_id = retargeting_tag_id
        self.advanced_tag = advanced_tag

    @property
    def account_id(self):
        """Gets the account_id of this RetargetingTag.  # noqa: E501

        <div lang=\"ja\">アカウントIDです。</div> <div lang=\"en\">Account ID.</div>   # noqa: E501

        :return: The account_id of this RetargetingTag.  # noqa: E501
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this RetargetingTag.

        <div lang=\"ja\">アカウントIDです。</div> <div lang=\"en\">Account ID.</div>   # noqa: E501

        :param account_id: The account_id of this RetargetingTag.  # noqa: E501
        :type: int
        """

        self._account_id = account_id

    @property
    def approval_status(self):
        """Gets the approval_status of this RetargetingTag.  # noqa: E501


        :return: The approval_status of this RetargetingTag.  # noqa: E501
        :rtype: RetargetingTagServiceApprovalStatus
        """
        return self._approval_status

    @approval_status.setter
    def approval_status(self, approval_status):
        """Sets the approval_status of this RetargetingTag.


        :param approval_status: The approval_status of this RetargetingTag.  # noqa: E501
        :type: RetargetingTagServiceApprovalStatus
        """

        self._approval_status = approval_status

    @property
    def retargeting_tag_id(self):
        """Gets the retargeting_tag_id of this RetargetingTag.  # noqa: E501

        <div lang=\"ja\">サイトリターゲティングのタグIDです。</div> <div lang=\"en\">Tag ID for site retargeting.</div>   # noqa: E501

        :return: The retargeting_tag_id of this RetargetingTag.  # noqa: E501
        :rtype: str
        """
        return self._retargeting_tag_id

    @retargeting_tag_id.setter
    def retargeting_tag_id(self, retargeting_tag_id):
        """Sets the retargeting_tag_id of this RetargetingTag.

        <div lang=\"ja\">サイトリターゲティングのタグIDです。</div> <div lang=\"en\">Tag ID for site retargeting.</div>   # noqa: E501

        :param retargeting_tag_id: The retargeting_tag_id of this RetargetingTag.  # noqa: E501
        :type: str
        """

        self._retargeting_tag_id = retargeting_tag_id

    @property
    def advanced_tag(self):
        """Gets the advanced_tag of this RetargetingTag.  # noqa: E501

        <div lang=\"ja\"> リニューアル版のサイトリターゲティングタグは、従来のタグよりもブラウザーなどの環境の影響を受けづらい新しいフォーマットです。<br> 詳細は、「<a href=\"https://ads-help.yahoo-net.jp/s/article/H000044890?language=ja\">サイトリターゲティングタグの取得とサイトへの設置</a>」を参照してください。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> The new format of site retargeting tag avoids the impacts such as changes made to the browser. <br> More details are described on <a href=\"https://ads-help.yahoo-net.jp/s/article/H000044890?language=en_US\">Acquire Site Retargeting Tag and Tagging on Site</a>.<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :return: The advanced_tag of this RetargetingTag.  # noqa: E501
        :rtype: str
        """
        return self._advanced_tag

    @advanced_tag.setter
    def advanced_tag(self, advanced_tag):
        """Sets the advanced_tag of this RetargetingTag.

        <div lang=\"ja\"> リニューアル版のサイトリターゲティングタグは、従来のタグよりもブラウザーなどの環境の影響を受けづらい新しいフォーマットです。<br> 詳細は、「<a href=\"https://ads-help.yahoo-net.jp/s/article/H000044890?language=ja\">サイトリターゲティングタグの取得とサイトへの設置</a>」を参照してください。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。 </div> <div lang=\"en\"> The new format of site retargeting tag avoids the impacts such as changes made to the browser. <br> More details are described on <a href=\"https://ads-help.yahoo-net.jp/s/article/H000044890?language=en_US\">Acquire Site Retargeting Tag and Tagging on Site</a>.<br> Although this field will be returned in the response, it will be ignored on input. </div>   # noqa: E501

        :param advanced_tag: The advanced_tag of this RetargetingTag.  # noqa: E501
        :type: str
        """

        self._advanced_tag = advanced_tag

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RetargetingTag):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, RetargetingTag):
            return True

        return self.to_dict() != other.to_dict()
